# $Revision: 1.55 $, $Date: 2009/02/07 16:56:33 $
#
# TODO:
# - define CONFIG_ option directly
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace programs
%bcond_with	verbose		# verbose build (V=1)

%if %{without kernel}
%undefine	with_dist_kernel
%endif

%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif

%define		subver		20081106
%define		prel		0.%{subver}.%{rel}

%define		pname		aufs
%define		rel		12
Summary:	aufs - Another Unionfs
Summary(pl.UTF-8):	aufs (Another Unionfs) - inny unionfs
Name:		%{pname}%{_alt_kernel}
Version:	0
Release:	%{prel}
License:	GPL v2
Group:		Base/Kernel
Source0:	%{pname}-%{subver}.tar.bz2
# Source0-md5:	9a0d8cdeae8706d51f7912b42f7dd438
Patch0:		%{pname}-vserver.patch
#Patch1:		%{pname}-disable-security_inode_permission.patch
Patch2:		%{pname}-fixes.patch
#Patch3:		%{pname}-spin_lock.patch
Patch4:		%{pname}-apparmor.patch
URL:		http://aufs.sourceforge.net/
%if %{with kernel}
%{?with_dist_kernel:BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.25.2}
BuildRequires:	rpmbuild(macros) >= 1.379
%endif
BuildRequires:	sed >= 4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
In the early days, aufs was entirely re-designed and re-implemented
Unionfs. After many original ideas, approaches, improvements and
implementations, it becomes totally different from Unionfs while
keeping the basic features. Unionfs is being developed by Professor
Erez Zadok at Stony Brook University and his team. If you don't know
Unionfs, I recommend you to try and know it before using aufs. Some
terminology in aufs follows Unionfs's.

%description -l pl.UTF-8
Początkowo aufs był całkowicie przeprojektowanym i od nowa
zaimplementowanym unionfs-em. Po wielu oryginalnych pomysłach,
podejściach, poprawkach i implementacjach stał sie całkowicie innym
niż unionfs zachowując podstawowe możliwości. unionfs jest rozwijany
przez profesora Ereza Zadoka w Stony Brook University i jego zespół.
Nie znający unionfs-a powinni spróbować go i poznać przed używaniem
aufs-a. Część terminologii wywodzi się z unionfs-a.

%package -n kernel%{_alt_kernel}-fs-aufs
Summary:	Linux driver for aufs
Summary(pl.UTF-8):	Sterownik dla Linuksa do aufs
Release:	%{prel}@%{_kernel_ver_str}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
%if %{with dist_kernel}
%requires_releq_kernel
Requires(postun):	%releq_kernel
%endif

%description -n kernel%{_alt_kernel}-fs-aufs
This is driver for aufs for Linux.

This package contains Linux module.

%description -n kernel%{_alt_kernel}-fs-aufs -l pl.UTF-8
Sterownik dla Linuksa do aufs.

Ten pakiet zawiera moduł jądra Linuksa.

%prep
%setup -qn %{pname}
%patch0 -p1
#%patch1 -p1
%patch2 -p1
#%patch3 -p1
if [ -d %{_kernelsrcdir}/security/apparmor ]; then
%patch4 -p1
fi

cp -a include/linux fs/aufs25

%build
%if %{with kernel}
if [ -f %{_kernelsrcdir}/include/linux/vs_base.h &&
     ! -d %{_kernelsrcdir}/security/apparmor ]; then
	isvserver="-DVSERVER"
fi
%ifarch %{x8664} ia64 ppc64 sparc64
	ino_t64="-DCONFIG_AUFS_INO_T_64"
%endif

export CONFIG_AUFS=m
export CONFIG_AUFS_BR_XFS=y
%build_kernel_modules -C fs/aufs25 -m aufs \
	EXTRA_CFLAGS+=" \
		-DCONFIG_AUFS_BRANCH_MAX_127 \
		-DCONFIG_AUFS_BRANCH_MAX_CHAR \
		-DCONFIG_AUFS_FAKE_DM \
		-DCONFIG_AUFS_MODULE \
		-UCONFIG_AUFS_KSIZE_PATCH \
		-UCONFIG_AUFS_DLGT \
%if "%{_alt_kernel}" != "vanilla"
		-DCONFIG_AUFS_UNIONFS23_PATCH \
		-DCONFIG_AUFS_UNIONFS22_PATCH \
		-DCONFIG_AUFS_SPLICE_PATCH \
%endif
		%{?debug:-DCONFIG_AUFS_DEBUG} \
		$isvserver \
		$ino_t64"
%endif

%if %{with userspace}
%{__make} -C util \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -DCONFIG_AUFS_BRANCH_MAX_127"
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT{%{_mandir}/man5,%{_sbindir}}
install util/{mount.aufs,umount.aufs,auplink,aulchown} $RPM_BUILD_ROOT%{_sbindir}
install util/aufs.5 $RPM_BUILD_ROOT%{_mandir}/man5/
%endif

%if %{with kernel}
%install_kernel_modules -m fs/aufs25/aufs -d kernel/fs/aufs
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-n kernel%{_alt_kernel}-fs-aufs
%depmod %{_kernel_ver}

%postun	-n kernel%{_alt_kernel}-fs-aufs
%depmod %{_kernel_ver}

%if %{with kernel}
%files -n kernel%{_alt_kernel}-fs-aufs
%defattr(644,root,root,755)
%dir /lib/modules/%{_kernel_ver}/kernel/fs/aufs
/lib/modules/%{_kernel_ver}/kernel/fs/aufs/*.ko*
%endif

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc README History
%attr(755,root,root) %{_sbindir}/*
%{_mandir}/man5/*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: aufs.spec,v $
Revision 1.55  2009/02/07 16:56:33  arekm
- release 12

Revision 1.54  2009/01/25 12:55:19  arekm
- release 11

Revision 1.53  2009/01/19 12:30:00  arekm
- release 10

Revision 1.52  2009/01/15 12:53:49  arekm
- release 9

Revision 1.51  2009/01/10 22:37:14  arekm
- release 8

Revision 1.50  2008/12/19 06:30:37  arekm
- release 7

Revision 1.49  2008/12/14 11:42:27  arekm
- release 6

Revision 1.48  2008/12/06 08:59:43  arekm
- release 5

Revision 1.47  2008/12/01 22:58:44  wolvverine
- rel.4:2.6.27.7-3

Revision 1.46  2008/11/21 16:15:16  arekm
- release 3

Revision 1.45  2008/11/08 09:26:37  arekm
- release 2

Revision 1.44  2008/11/07 14:38:31  tommat
- rel 1, working with LINUX_2_6 2.6.27.4-2 and vanilla kernel

Revision 1.43  2008/11/06 09:41:28  tommat
- new snap 20081106

Revision 1.42  2008/11/05 10:23:48  zbyniu
- rel 1

Revision 1.41  2008/11/05 10:12:04  zbyniu
- added apparmor support (apparmor.patch)

Revision 1.40  2008/11/04 21:29:45  zbyniu
- set CONFIG_AUFS_INO_T_64 for 64bit archs; cleanup

Revision 1.39  2008/10/30 22:33:47  qwiat
- 20081030

Revision 1.38  2008/10/13 20:47:33  arekm
- release 11

Revision 1.37  2008/09/03 10:15:00  hawk
- suffix src package with alt kernel name (if present)
- disable userspace for alt_kernels

Revision 1.36  2008/09/02 06:41:26  arekm
- release 10

Revision 1.35  2008/08/07 17:50:23  arekm
- release 9

Revision 1.34  2008/08/03 10:19:40  arekm
- release 8

Revision 1.33  2008/07/25 07:10:00  arekm
- release 7

Revision 1.32  2008/07/19 08:00:30  arekm
- release 6

Revision 1.31  2008/07/15 09:15:22  arekm
- release 5

Revision 1.30  2008/07/02 20:43:01  arekm
- release 4

Revision 1.29  2008/06/26 06:45:41  arekm
- release 3

Revision 1.28  2008/06/24 11:23:59  arekm
- release 2

Revision 1.27  2008-05-28 14:03:57  zbyniu
- export CONFIG_AUFS=m

Revision 1.26  2008-05-27 08:22:42  zbyniu
- md5sum

Revision 1.25  2008-05-27 08:20:27  zbyniu
- up to 20080527; fixes.patch and spin_lock.patch added, disable-security_inode_permission.patch restored

Revision 1.24  2008-05-17 20:54:49  areq
- 20080517

Revision 1.23  2008-05-09 21:48:30  areq
- 20080509 (only for 2.6.25)

Revision 1.22  2008-03-27 20:55:28  glen
- rel 11 (2.6.22.19-5)

Revision 1.21  2008-03-19 14:59:21  zbyniu
- vserver bcond removed, autodetection

Revision 1.20  2008-03-13 23:28:26  zbyniu
- up to 20080313 snap
- patch to disable security_inode_permission export in kernel (needs check)

Revision 1.19  2008-03-10 12:21:05  arekm
- release 10

Revision 1.18  2008-02-11 11:31:43  arekm
- rel 9

Revision 1.17  2008-01-22 22:54:32  glen
- rel 8 (2.6.16.59-2)

Revision 1.16  2007-12-17 14:17:16  arekm
- rel .7

Revision 1.15  2007-12-15 11:56:45  arekm
- rel .6

Revision 1.14  2007-11-29 08:01:08  arekm
- rel .5

Revision 1.13  2007-11-25 10:33:04  arekm
- rel .4

Revision 1.12  2007-10-24 13:50:18  arekm
- rel .3

Revision 1.11  2007/10/17 15:57:53  areq
- 20071017

Revision 1.10  2007/10/12 12:48:14  arekm
- rel .2

Revision 1.9  2007/09/16 19:56:38  areq
- 20070914

Revision 1.8  2007/06/03 12:47:35  areq
- BR kernel-module-build >= 3:2.6.20.2

Revision 1.7  2007/06/03 12:36:17  areq
- 20070528
- install mount.aufs umount.aufs auplink aulchown

Revision 1.6  2007/04/25 12:31:04  pascalek
- sources fetched by distfiles

Revision 1.5  2007/04/25 11:08:44  pascalek
- bcond comment causes build to fail
- module moved to proper location

Revision 1.4  2007/04/25 10:53:07  pascalek
- new cvs snapshot - 2007.04.24
- vserver patch and bcond
- prepared for smponly kernel
- builds now but CONFIG_AUFS_SYSAUFS should be y and need fixing

Revision 1.3  2007/03/03 10:23:05  qboosh
- pl

Revision 1.2  2007/02/20 23:21:35  sparky
- builds

Revision 1.1  2007/02/20 21:45:32  glen
- new, smb else finish this
